var Points, TotPoints, CurPoints, BuyType, BuyOut, Started;
var Str, Dex, Intl, Con, Cha;
var StrBns, DexBns, IntlBns, ConBns, ChaBns;
var CurStr,CurDex,CurIntl,CurWis,CurCon,CurCha;
var MinStat

Started = false;

function Start() {
  Points = document.forms[0].Points;
  TotPoints = document.forms[0].TotPoints;
  CurPoints = document.forms[0].CurPoints;
	BuyType   = document.forms[0].BuyType;
  Str       = document.forms[0].Str;
  Dex       = document.forms[0].Dex;
  Intl      = document.forms[0].Intl;
  Wis       = document.forms[0].Wis;
  Con       = document.forms[0].Con;
  Cha       = document.forms[0].Cha;
	StrBns    = document.forms[0].StrBns;
	DexBns    = document.forms[0].DexBns;
	IntlBns    = document.forms[0].IntlBns;
	WisBns    = document.forms[0].WisBns;
	ConBns    = document.forms[0].ConBns;
	ChaBns    = document.forms[0].ChaBns;
	BuyOut    = document.forms[0].CurBuy;
	CurStr    = 8;
	CurDex    = 8;
	CurIntl   = 8;
	CurWis    = 8;
	CurCon    = 8;
	CurCha    = 8;

  if(isNaN(Points.value)) {
	  alert("Points must be an integer value.\nDefaulting to 32");
		Points.value = 32;
	}
	TotPoints.value = Points.value;
	CurPoints.value = Points.value;
	Str.value  = 8;
	Dex.value  = 8;
	Intl.value = 8;
	Wis.value  = 8;
	Con.value  = 8;
	Cha.value  = 8;
	StrBns.value = -1;
	DexBns.value = -1;
	IntlBns.value = -1;
	WisBns.value = -1;
	ConBns.value = -1;
	ChaBns.value = -1;
	
	if(BuyType.value == 2) {
	  BuyOut.value = "Graduated";
		MinStat = 8;
	}
	else {
	  BuyOut.value = "Flat";
		MinStat = 3;
		CurPoints.value = TotPoints.value - (8 * 6);
	}
	Started = true;
	Str.focus();
	return true;
}

function RecalcPoints(Stat) {
  var PointsUsed;
	var CurStat,CurStatVal,CurStatBns;
	
	if(!Started) {
	  alert("Please press start before you begin adjusting stats.");
		return false;
	}
	
	switch (Stat) {
	  case 'Str':
		  CurStat = Str;
			CurStatVal = CurStr;
			CurStatBns = StrBns;
		  break;
	  case 'Dex':
		  CurStat = Dex;
			CurStatVal = CurDex;
			CurStatBns = DexBns;
		  break;
	  case 'Int':
		  CurStat = Intl;
			CurStatVal = CurIntl;
			CurStatBns = IntlBns;
		  break;
	  case 'Wis':
		  CurStat = Wis;
			CurStatVal = CurWis;
			CurStatBns = WisBns;
		  break;
	  case 'Con':
		  CurStat = Con;
			CurStatVal = CurCon;
			CurStatBns = ConBns;
		  break;
	  case 'Cha':
		  CurStat = Cha;
			CurStatVal = CurCha;
			CurStatBns = ChaBns;
		  break;
	}
	
  if(isNaN(CurStat.value)) {
	  alert("You must enter an integer between 8 and 18 for " + Stat);
		CurStat.value = CurStatVal;
		CurStat.focus();
		return;  
	}
	else if(CurStat.value < 8 || CurStat.value > 18) {
	  alert("You must enter an integer between 8 and 18 for " + Stat);
		CurStat.value = CurStatVal;
		CurStat.focus();
		return;
	}
	
	
	if(BuyOut.value == 'Graduated') {PointsUsed = CalcGraduated();}
	else {PointsUsed = CalcFlat();}
	
	if (PointsUsed > TotPoints.value) {
	  alert("You have used more points then you have.\nResearch indicates that this is bad form.");
		CurStat.value = CurStatVal;
	}
	
	switch (Stat) {
	  case 'Str':
			CurStr = Str.value;
		  break;
	  case 'Dex':
			CurDex = Dex.value;
		  break;
	  case 'Int':
			CurIntl = Intl.value;
		  break;
	  case 'Wis':
			CurWis = Wis.value;
		  break;
	  case 'Con':
			CurCon = Con.value;
		  break;
	  case 'Cha':
			CurCha = Cha.value;
		  break;
	}
	
	CurPoints.value = (TotPoints.value - PointsUsed);
	CurStatBns.value = Math.floor((parseInt(CurStat.value)/2)-5);
}

function CalcGraduated() {
  var PointsUsed;
	
	if (Str.value > 16) {PointsUsed = 6 + 4 + ((Str.value - 16) * 3);}
	else if (Str.value > 14) {PointsUsed = 6 + ((Str.value - 14) * 2);}
	else {PointsUsed = Str.value - 8;}  

	if (Dex.value > 16) {PointsUsed = PointsUsed + (6 + 4 + ((Dex.value - 16) * 3));}
	else if (Dex.value > 14) {PointsUsed = PointsUsed + ( 6 + ((Dex.value - 14) * 2));}
	else {PointsUsed =  PointsUsed + (Dex.value - 8);}  

	if (Intl.value > 16) {PointsUsed = PointsUsed + (6 + 4 + ((Intl.value - 16) * 3));}
	else if (Intl.value > 14) {PointsUsed = PointsUsed + ( 6 + ((Intl.value - 14) * 2));}
	else {PointsUsed =  PointsUsed + (Intl.value - 8);}  

	if (Wis.value > 16) {PointsUsed = PointsUsed + (6 + 4 + ((Wis.value - 16) * 3));}
	else if (Wis.value > 14) {PointsUsed = PointsUsed + ( 6 + ((Wis.value - 14) * 2));}
	else {PointsUsed =  PointsUsed + (Wis.value - 8);}  

	if (Con.value > 16) {PointsUsed = PointsUsed + (6 + 4 + ((Con.value - 16) * 3));}
	else if (Con.value > 14) {PointsUsed = PointsUsed + ( 6 + ((Con.value - 14) * 2));}
	else {PointsUsed =  PointsUsed + (Con.value - 8);}  

	if (Cha.value > 16) {PointsUsed = PointsUsed + (6 + 4 + ((Cha.value - 16) * 3));}
	else if (Cha.value > 14) {PointsUsed = PointsUsed + ( 6 + ((Cha.value - 14) * 2));}
	else {PointsUsed =  PointsUsed + (Cha.value - 8);}
	
	return PointsUsed; 	
}

function CalcFlat() {
  var PointsUsed;
	PointsUsed = parseInt(Str.value);
	PointsUsed = PointsUsed + parseInt(Dex.value);
	PointsUsed = PointsUsed + parseInt(Intl.value);
	PointsUsed = PointsUsed + parseInt(Wis.value);
	PointsUsed = PointsUsed + parseInt(Con.value);
	PointsUsed = PointsUsed + parseInt(Cha.value);
	return PointsUsed;
}

function ResetStats() {
	if(!Started) {
	  alert("Please press start before you begin adjusting stats.");
		return false;
	}
	
	TotPoints.value = Points.value;
	CurPoints.value = Points.value;
	Str.value  = 8;
	Dex.value  = 8;
	Intl.value = 8;
	Wis.value  = 8;
	Con.value  = 8;
	Cha.value  = 8;
	StrBns.value = -1;
	DexBns.value = -1;
	IntlBns.value = -1;
	WisBns.value = -1;
	ConBns.value = -1;
	ChaBns.value = -1;
	Str.focus();
	return true;
}